# AI ECA - Agents

WARNING: this agent has the capability of creating and editing ECA models, without "realizing" that the result may be
destructive. Meaning that, if you ask it to create a model that removes all nodes when a user logs in, nothing is
holding it back.
USE AT YOUR OWN RISK!

## Scope

- Answer questions about existing models
- Answer questions about specific components, like events, conditions or actions
- Create new models
- Edit existing models

## Usage

- Go to `/admin/config/workflow/eca`
- Click on `Ask AI` and write down your question
    - The same button is available on the edit-screen of a model

## Roadmap

This has no specific order or priority, just things that I can think of right now

- Make the prompt more "deterministic": there's an issue where the LLM edits an existing model and doesn't follow the provided JSON schema
- Refactor the custom Typed Data model once config validation is in core
    - [https://www.drupal.org/project/eca/issues/3446331](https://www.drupal.org/project/eca/issues/3446331)
- Create a separate sub-agent that can interpret an image and provide a prompt for the main one
    - See Webform Agent

## Resources

- [https://webthesis.biblio.polito.it/31175/1/tesi.pdf](https://webthesis.biblio.polito.it/31175/1/tesi.pdf)
- [https://github.com/RobJenks/gpt-codegen](https://github.com/RobJenks/gpt-codegen)
- [https://github.com/jtlicardo/bpmn-assistant](https://github.com/jtlicardo/bpmn-assistant)
- [https://ceur-ws.org/Vol-3758/paper-15.pdf](https://ceur-ws.org/Vol-3758/paper-15.pdf)
